<!--  Represents the 'Upload' page. -->
<template>
  <div class="container-fluid mb-5">
    <div class="row">
      <uploadPageTop :activeStep="getStep"></uploadPageTop>
    </div>
    <div class="row">
      <div v-if="getLoading" class="loading-spinner mx-auto mt-3 mb-3"></div>
      <router-view v-else name="uploadSubpages"></router-view>
    </div>
    <div class="row">
      <uploadPageBottom :activeStep="getStep"></uploadPageBottom>
    </div>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex';
  import { glueConfig as GLUE_CONFIG } from '../../../config/user-config';
  import UploadPageTop from './EDP2-uploadPage-top';
  import UploadPageBottom from './EDP2-uploadPage-bottom';

  export default {
    name: 'Upload',
    components: {
      uploadPageTop: UploadPageTop,
      uploadPageBottom: UploadPageBottom,
    },
    metaInfo() {
      return {
        title: this.$t('message.metadata.upload'),
        meta: [
          { name: 'description', vmid: 'description', content: `${this.$t('message.metadata.upload')} - ${this.$t('message.header.european')} ${this.$t('message.header.dataPortal')}` },
          { name: 'keywords', vmid: 'keywords', content: `${GLUE_CONFIG.keywords} ${this.$t('message.metadata.upload')}` },
          { property: 'robots', content: 'follow,noindex' },
        ],
      };
    },
    data() {
      return {
        steps: {
          1: 'UploadPageDatasetDetails',
          2: 'UploadPageDistributions',
          3: 'UploadPageFileUpload',
          4: 'UploadPageReview',
        },
      };
    },
    props: {},
    computed: {
      ...mapGetters('upload', [
        'getStep',
        'getLoading',
      ]),
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'resetStore',
      ]),
      deleteLocalStorage(deleteStorage) {
        // Check if user wants to delete the storage
        if (deleteStorage) {
          // Clear local storage
          if (localStorage.getItem('catalogue')) {
            localStorage.setItem('catalogue', '');
          }
          if (localStorage.getItem('title')) {
            localStorage.setItem('title', '');
          }
          if (localStorage.getItem('description')) {
            localStorage.setItem('description', '');
          }
          if (localStorage.getItem('keywords')) {
            localStorage.setItem('keywords', '');
          }
          if (localStorage.getItem('categories')) {
            localStorage.setItem('categories', '');
          }
          if (localStorage.getItem('contact')) {
            localStorage.setItem('contact', '');
          }
          if (localStorage.getItem('publisher')) {
            localStorage.setItem('publisher', '');
          }
          if (localStorage.getItem('apiUploadData')) {
            localStorage.setItem('apiUploadData', '');
          }
          if (localStorage.getItem('ID')) {
            localStorage.setItem('ID', '');
          }
          if (localStorage.getItem('distributions')) {
            localStorage.setItem('distributions', '');
          }
          if (localStorage.getItem('distribution')) {
            localStorage.setItem('distribution', '');
          }
          if (localStorage.getItem('files')) {
            localStorage.setItem('files', '');
          }
        }
      },
    },
    watch: {},
    created() {
      // Initially set step navigation on reload
      if (this.$route.name === 'UploadPageDatasetDetails') {
        this.setStep(1);
      } else if (this.$route.name === 'UploadPageDistributions') {
        this.setStep(2);
      } else if (this.$route.name === 'UploadPageFileUpload') {
        this.setStep(3);
      } else if (this.$route.name === 'UploadPageReview') {
        this.setStep(4);
      } else if (this.getStep === null) {
        // Initially set Step to 1
        this.setStep(1);
      }
    },
    beforeRouteLeave(to, from, next) {
      // Check if user is leaving the data upload form
      if (!to.path.startsWith('/upload') && this.getStep !== null) {
        // Reset store data
        this.resetStore();
        // Delete local storage session if data upload finished
        if (this.getStep === 4) {
          this.deleteLocalStorage(true);
        } else this.setStep(null);
      }
      next();
    },
  };
</script>

<style scoped lang='scss'>
  @import '../../styles/bootstrap_theme';
  @import '../../styles/utils/css-animations';
</style>
